package de.unibw.i2.mi.oo;

/**
 * A method consisting of a signature and an implementation in a class. The
 * current implementation does not represent the method body yet.
 */
public class MIMethod {
	private final MIClass myClass;
	private final MIMethodSignature sig;

	public MIMethod(MIClass myClass, MIMethodSignature sig) {
		super();
		this.myClass = myClass;
		this.sig = sig;
	}

	/**
	 * Returns the class that provides this method implementation.
	 */
	public MIClass getImplementingClass() {
		return myClass;
	}

	/*
	 * Returns the signature of this method.
	 */
	public MIMethodSignature getSig() {
		return sig;
	}

	@Override
	public String toString() {
		return "MIMethod [myClass=" + myClass.getName() + ", sig=" + sig + "]";
	}

	public String shortString() {
		return myClass.getName() + "::" + sig.shortString();
	}
}
