package de.unibw.i2.mi.oo;

/**
 * The signature of a method. Only a method name is currently supported. Two
 * signature are considered equal if their method names are equal.
 */
public class MIMethodSignature {
	public final static MIMethodSignature UPCAST = new MIMethodSignature(
			"upcast");

	private final String name;

	public MIMethodSignature(String name) {
		super();
		this.name = name;
	}

	public String getName() {
		return name;
	}

	@Override
	public String toString() {
		return "MIMethodSignature [name=" + name + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		MIMethodSignature other = (MIMethodSignature) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}

	public String shortString() {
		return getName();
	}
}
