package de.unibw.i2.mi.oo.parser;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

class AClass {
	private final boolean isAbstract;
	private final boolean interf;
	private final String name;
	private String superClass;
	private List<String> interfaces = Collections.emptyList();
	private final List<AMethod> methods = new ArrayList<AMethod>();

	public static AClass makeClass(String name, boolean isAbstract) {
		return new AClass(name, isAbstract, false);
	}

	public static AClass makeInterface(String name) {
		return new AClass(name, true, true);
	}

	private AClass(String name, boolean isAbstract, boolean interf) {
		super();
		this.isAbstract = isAbstract;
		this.name = name;
		this.interf = interf;
	}

	public boolean isInterf() {
		return interf;
	}

	public String getSuperClass() {
		return superClass;
	}

	public void setSuperClass(String superClass) {
		this.superClass = superClass;
	}

	public List<String> getInterfaces() {
		return interfaces;
	}

	public void setInterfaces(List<String> interfaces) {
		this.interfaces = interfaces;
	}

	public String getName() {
		return name;
	}

	public void addMethod(AMethod aMeth) {
		methods.add(aMeth);
	}

	public List<AMethod> getMethods() {
		return methods;
	}

	public boolean isAbstract() {
		return isAbstract;
	}

	@Override
	public String toString() {
		StringBuffer buf = new StringBuffer();
		if (isInterf())
			buf.append("Interface [");
		else if (isAbstract())
			buf.append("Abstract class [");
		else
			buf.append("Class [");
		buf.append("name=" + name);
		if (!isInterf())
			buf.append(", superClass=").append(superClass);
		if (!getInterfaces().isEmpty())
			buf.append(", interfaces=").append(interfaces);
		buf.append(", methods=").append(methods).append("]");
		return buf.toString();
	}
}
